<template>
    <div v-if="limit" class="columns">
        <div class="column is-paddingless">
            <div class="columns is-mobile">
                <div class="column is-2">
                    <a
                        v-bind:style="{
                            backgroundColor: limit.color,
                            borderColor: blender.blend(limit.color, '#000000', 0.3)
                        }"
                        v-on:mouseover="genColorButtonStyle($event.target, limit.color, 0.1)"
                        v-on:mouseleave="genColorButtonStyle($event.target, limit.color)"
                        v-on:click="palette = ! palette"
                        class="button is-small is-rounded palette-color is-marginless"
                    />
                </div>
                <div class="column is-6">
                    <input
                        v-bind:value="limit.value"
                        v-on:input="(limit.value = $event.target.value) && map._focused.updateColors(map._mapboxMap)"
                        class="slider"
                        step="0.1" 
                        min="0" max="1000"
                        type="range"
                    >
                </div>
                <div class="column is-hpaddingless">
                    <input
                        v-bind:value="limit.value" 
                        v-on:input="(limit.value = $event.target.value) && map._focused.updateColors(map._mapboxMap)" 
                        class="input is-small is-rounded"
                        min="0" max="1000"
                        type="number"
                    >
                </div>
            </div>
            <div v-if="palette" class="column is-vpaddingless">
                <a
                    v-bind:key="color.key" 
                    v-for="color in PALETTE"
                    v-bind:style="{
                        backgroundColor: color,
                        borderColor: blender.blend(color, '#000000', 0.3)
                    }"
                    v-on:mouseover="genColorButtonStyle($event.target, color, 0.1)"
                    v-on:mouseleave="genColorButtonStyle($event.target, color)"
                    v-on:click="(limit.color = color) && map._focused.updateColors(map._mapboxMap)"
                    class="button is-small is-rounded palette-color"
                />
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue } from 'vue-property-decorator';
    import { State } from 'vuex-class';
    import IconBase from './IconBase.vue';

    import { COLORS } from '@/ts/enums';
    import { Blender } from '@/ts/blender';
    import { Folder } from '@/ts/folder';
    import { Mapview } from '@/ts/mapview';

    @Component({
        components: {
            IconBase,
        },
    })
    export default class LimitSetter extends Vue {
        @Prop()
        private limit!: Limit;

        @State('map') private map!: Mapview;

        private readonly PALETTE = [
            COLORS.BLUE,
            COLORS.GREEN,
            COLORS.YELLOW,
            COLORS.ORANGE,
            COLORS.RED,
            COLORS.PURPLE,
            COLORS.GREY,
            COLORS.WHITE,
        ];
        private blender: Blender = new Blender();
        private palette: boolean = false;

        private genColorButtonStyle(element: any, color: string, percentage?: number) {
            if (percentage === undefined) {
                element.style.backgroundColor = color;
                element.style.borderColor = this.blender.blend(color, '#000000', 0.3);
            } else {
                element.style.backgroundColor = this.blender.blend(color, '#000000', percentage);
                element.style.borderColor = this.blender.blend(color, '#000000', percentage + 0.3);
            }
        }
    }
</script>

<style scoped>
    .palette-color {
        border-width: 2px;
        margin: 0.2rem;
    }

    .slider {
        -webkit-appearance: none;
        height: 4px;
        width: 100%;
        border-radius: 5px;
        background: #d4d4d4;
        outline: none;
        opacity: 1;
        /* margin: 0.5rem; */
        -webkit-transition: .2s;
        transition: opacity .2s;
    }

    .slider::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 12px;
        height: 12px;
        border-radius: 50%;
        background-color: #4a4a4a;
        cursor: pointer;
    }
</style>
